# -*- coding: utf-8 -*-
# Copyright 2010-2013 Kolab Systems AG (http://www.kolabsys.com)
#
# Jeroen van Meeuwen (Kolab Systems) <vanmeeuwen a kolabsys.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import os
import sys

from pykolab.introspection import *
import pykolab

from pykolab.translate import _
from pykolab import utils

conf = pykolab.getConf()

commands = {}

def __init__():
    import_commands(os.path.dirname(__file__), "pykolab.cli", "cmd_", commands)

    register('help', lambda *args, **kw: list_commands(commands, *args, **kw))

    register('list_users', not_yet_implemented, description="Not yet implemented")
    register('delete_user', not_yet_implemented, description="Not yet implemented")

    register('list_groups', not_yet_implemented, description="Not yet implemented")
    register('add_group', not_yet_implemented, description="Not yet implemented")
    register('delete_group', not_yet_implemented, description="Not yet implemented")

def execute(cmd_name, *args, **kw):
    if cmd_name == "":
        execute("help")
        sys.exit(0)

    if not commands.has_key(cmd_name):
        utils.message(_("No such command."))
        sys.exit(1)

    if not commands[cmd_name].has_key('function') and \
        not commands[cmd_name].has_key('group'):
        utils.message(_("No such command."))
        sys.exit(1)

    import_command_options(cmd_name, "cmd_name", "pykolab.cli", "cmd_", commands)

    conf.finalize_conf()
    commands[cmd_name]['function'](conf.cli_args, kw)

def register(*args, **kw):
    register_command(commands, "cmd_name", *args, **kw)
